'use strict';

const emitter = require('./emitter');
const logger = require('./logger');

function Provider (options, callback) {
  if (arguments.length === 1 && typeof options === 'function') {
    callback = options;
    options = {};
  }

  return function (event, context, done) {
    options = Object.assign({
      name: context.functionName,
      logLevel: 'info'
    }, options);
    options.logger = logger(options);
    options.logger.info(event, 'Received query');
    callback(event.params, emitter(options, event, done));
  };
}

module.exports = Provider;
